SystemOrganization addCategory: #'Magritte-CustomBuilder'!

!MANamedBuilder methodsFor: '*magritte-custombuilder-override' stamp: 'kph 8/19/2007 01:21'!
build: anObject
	| selectors container description |
	
	selectors := (anObject class allSelectorsBelow: ProtoObject class) select: [ :each | each isDescriptionSelector ].
	container := self build: anObject for: self containerSelector in: selectors.
	^ (selectors select: [ :each | each isDescriptionDefinition ])
		inject: (cache at: anObject put: container)
		into: [ :result :each |
			self containerSelector = each ifFalse: [
				description := self build: anObject for: each in: selectors.
				description isDescription
					ifTrue: [ result add: description ] ].
			result ]! !

MADescriptionBuilder subclass: #MACustomDescriptionBuilder
	instanceVariableNames: 'prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-CustomBuilder'!

MACustomDescriptionBuilder class
	instanceVariableNames: 'instances'!

MACustomDescriptionBuilder class
	instanceVariableNames: 'instances'!

!MACustomDescriptionBuilder class methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 00:05'!
initialize
	instances := nil.
	self default:  (MACustomPrioritizedDescriptionBuilder prefix: #description)! !

!MACustomDescriptionBuilder class methodsFor: 'as yet unclassified' stamp: 'kph 10/17/2007 17:07'!
freeSomeSpace

	^ self initialize! !

!MACustomDescriptionBuilder class methodsFor: 'as yet unclassified' stamp: 'kph 9/10/2007 17:51'!
instances

	^ instances ifNil: [ instances := IdentityDictionary new ]! !

!MACustomDescriptionBuilder class methodsFor: 'as yet unclassified' stamp: 'kph 9/10/2007 17:51'!
prefix: aPrefixSymbol 
	^ self instances at: aPrefixSymbol
		ifAbsentPut: 
			[(self basicNew)
				setPrefix: aPrefixSymbol;
				initialize;
				yourself]! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/19/2007 01:25'!
build: anObject
	| selectors container description |
	selectors := (anObject class allSelectorsBelow: ProtoObject class) select: [ :each | self isThisOurs: each ].
	container := self build: anObject for: self containerSelector in: selectors.
	^ (selectors select: [ :each | self isThisOneOfOurDefinitions: each ])
		inject: (cache at: anObject put: container)
		into: [ :result :each |
			self containerSelector = each ifFalse: [
				description := self build: anObject for: each in: selectors.
				description isDescription
					ifTrue: [ result add: description ] ].
			result ]! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 02:17'!
build: anObject for: aSelector in: aCollection
	^ (aCollection select: [ :each | self isThis: each anExtensionOf: aSelector ])
		inject: (anObject perform: aSelector)
		into: [ :result :each | anObject perform: each with: result ]! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 01:50'!
containerSelector
	^ #descriptionContainer! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 02:16'!
isThis: selector anExtensionOf: orig

	"Answer whether the receiver is a method selector following the naming conventions of a 'custom' description extension to aSelector."

	^ (self isThisOurs: selector)
		and: [ selector numArgs = 1
		and: [ selector beginsWith: orig ] ]! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 02:22'!
isThisOneOfOurDefinitions: selector 
	"Answer wheter the receiver is a method selector following the naming conventions of a description definition."

	^ (self isThisOurs: selector)
		and: [ selector isUnary ]! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 02:14'!
isThisOurs: selector 

	"Answer wheter the receiver is a method selector following the naming conventions of a  our 'custom' description selector."

	^ selector ~= prefix and: [ selector beginsWith: prefix ]! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 9/10/2007 17:57'!
printOn: stream

	super printOn: stream.
	stream nextPutAll: prefix printString
	
! !

!MACustomDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 8/18/2007 02:10'!
setPrefix: aPrefix

 prefix := aPrefix! !

MACustomDescriptionBuilder subclass: #MACustomPrioritizedDescriptionBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-CustomBuilder'!

!MACustomPrioritizedDescriptionBuilder methodsFor: 'as yet unclassified' stamp: 'kph 12/14/2007 21:02'!
build: anObject for: prioritizedSelector in: aCollection

	"prioritizedSelector of the form description0001Test"
	
	| tail priority aSelector description |
	tail := prioritizedSelector allButFirst: prefix size.
	priority := tail asInteger. 
	tail := tail withoutLeadingDigits.
 
	aSelector := (prefix , tail) asSymbol.

	description := (aCollection select: [ :each | self isThis: each anExtensionOf: aSelector ])
		inject: (anObject perform: prioritizedSelector)
		into: [ :result :each | anObject perform: each with: result ].
		
	(priority notNil and: [ description isDescription ]) ifTrue: [ description priority: priority ].
	
	^ description! !
MACustomDescriptionBuilder initialize!
